Subject: Re: [PATCH v8 03/25] net/ethtool: add ULP_DDP_{GET,SET} operations for caps and stats

From: Jakub Kicinski <[email-masked]>
Date: Thu, 12 Jan 2023 15:47:00 -0800

On Thu, 12 Jan 2023 18:50:16 +0000 Aurelien Aptel wrote:
> > The implementation of stats is not what I had in mind.
> > None of the stats you listed under "Statistics" in the documentation look nVidia
> > specific. The implementation should look something like the pause frame stats
> > (struct ethtool_pause_stats etc) but you can add the dynamic string set if you
> > like.
> > 
> > If given implementation does not support one of the stats it will not fill in the
> > value and netlink will skip over it. The truly vendor- -specific stats (if any) can go
> > to the old ethtool -S.  
> 
> Do you mean that we could use the dynamic string approach and just
> define the counters names in netlink? Our concern is that it will not
> allow us to have those stats per queue (as we do in the mlx patches),
> in that case we can suggest reusing ethtool -Q option to request
> per-queue stats. What do you think?

The standard ethtool interface should expose the accumulated stats.
The stats of finer granularity need to be reported on the object to
which they are scoped. 

I'm still yet to find any practical use for per-queue stats in
production.

IOW report the cumulative per device stats in ethtool -I --your-switch.
The per-queue stats can go to ethtool -S until someone actually finds 
a good reason to read them in production..